#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/socket.h>
#include <string.h>
#include <errno.h>
#include <arpa/inet.h>

#include "data.h"



int main(int argc, const char *argv[]){
	struct sockaddr_in server_addr;
	int sock, rec;
	char buffer[BLOCK_SIZE];
	FILE *fp; 
	fileinfo fp_info;
	struct stat fp_data;
	
	/* Parametry z shellu */
	if(argc < 3) 
	{
		puts("./client <IP> <soubor>");
		return 0;
		/* ./client <IP> <soubor> */
	}

	/* Otevreni souboru */
	if((fp = fopen(argv[2], "rb"))<=0){
		ERROR("Openning file");
	}
	
	/* Zjisteni velikosti */
	stat(argv[2], &fp_data); 
	fp_info.file_size = (unsigned int) fp_data.st_size;
	strncpy(fp_info.file_name, argv[2], sizeof(fp_info.file_name));
	printf("File to transfer: '%s' %u Bytes\n", fp_info.file_name, fp_info.file_size);

	
	/* Vytvoreni socketu */
	if((sock = socket(AF_INET, SOCK_STREAM, 0))<=0){
		ERROR("Socket");	
	}

	/* Nastaveni parametru spojeni */
	memset(&server_addr, 0, sizeof(server_addr));
	server_addr.sin_family = AF_INET;
	server_addr.sin_addr.s_addr = (unsigned long int) inet_addr(argv[1]);
	server_addr.sin_port = htons(SERV_PORT);	
	
	if((connect(sock, (struct sockaddr *) &server_addr, sizeof(server_addr) ))<0){
		ERROR("Connect");	
	}

		
	/* Posilani souboru */
	write(sock, &fp_info, sizeof(fp_info));
	
	/* Pozor fread se musi bytove orientovat !! */
	while((rec = fread(buffer, 1, sizeof(buffer), fp))!=0){
		/* Zapis dat do socketu */
		if(write(sock, buffer, rec)<=0){
			ERROR("Write socket");	
		};
	}

	printf("Soubor %s prenesen na %s\n", argv[2], argv[1]);
	
	close(sock);
	fclose(fp);

	return 0;
}
