#include <fcntl.h>
#include <errno.h>
#include <netdb.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>

#include "data.h"

#define BUFFER 8192

#define TIME_OUT 5

int main(int argc, char *argv[]){
	int sock, comm_sock;
	struct sockaddr_in adresa;
	char buffer[BUFFER];
	int rec, ukazatel;
	int sock_param = 1;
	FILE *fw;
	fileinfo fw_info;
	pid_t RX;

	memset(&buffer, 0, sizeof(buffer));
	
	/* Vytvoreni socketu */
	/* IPPROTO_TCP = 0 */
	if( (sock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) == -1){ ERROR("Socket") }

	
	/* Nastaveni parametru socketu */
	setsockopt(sock , SOL_SOCKET, SO_REUSEADDR , &sock_param, sizeof(int));
	
	memset(&adresa, 0, sizeof(adresa));	 /* Zapise na adresu nulove byty */
	adresa.sin_family = AF_INET;
	adresa.sin_port = htons(SERV_PORT);
	
	if( (bind(sock, (struct sockaddr *) &adresa, sizeof(adresa))) == -1){ ERROR("Bind") }

	/* Nastaveni stavu cekani */
	if(listen(sock, 5) == -1){ ERROR("Listen") }

	/* Vytvoreni noveho socketu po navazani spojeni */
	if( (comm_sock = accept(sock, NULL, 0)) == -1 ) { ERROR("Accept") }
	
 
	RX = fork();

	/* RX podproces */
	if(!RX){ 
	close(sock); 
	/* Prvni paket obsahuje informace o prijimanem souboru */
	
	printf("Prijimam data\n");
	
	read(comm_sock, &fw_info, sizeof(fw_info));
	printf("File: %s %u\n", fw_info.file_name, fw_info.file_size);
	
	/* Otevreni souboru */
	fw = fopen("serv_receive.dat", "wb");
	
	/* funkce read neodstranuje data z fronty, takze
	   se posunuje ukazatel pro jejich zapis */
	ukazatel = 0;
	do {
		rec = read(comm_sock, buffer, BUFFER);
		
/*		printf("%d %s \n", rec, buffer+ukazatel);*/
		if(rec<=0)
			break;
		
		if((fwrite(buffer, 1, rec, fw))!=rec){ ERROR("File write") }
		
/*		printf("Nacteno: %d\n", rec); */
		ukazatel += rec;
	} while(1);

	printf("Prijato: %d bytu.\n", ukazatel);
	
	fclose(fw);
	close(comm_sock);
	
	return(0);
	}
	/* ************************************************* */

	printf("Konec\n");
	return 0;
}

